﻿
Partial Class Form1
    Inherits System.Windows.Forms.Form

    ' ===================================================================================================
    '  OPEN CLOSE PANELS
    ' ===================================================================================================
    Private ReadOnly PanelHeight(3) As Int32

    Private Sub InitPanels()
        PanelHeight(1) = GroupBox1.Height
        PanelHeight(2) = GroupBox2.Height
        PanelHeight(3) = GroupBox3.Height
    End Sub

    Private Sub GroupBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox1.Click,
                                                                                            GroupBox2.Click,
                                                                                            GroupBox3.Click
        Dim gbox As GroupBox = CType(sender, GroupBox)
        If gbox.PointToClient(MousePosition).Y > 20 Then Return
        ToggleGboxHeight(gbox)
        UpdateAllPanels()
        SetVisibleButtons()
    End Sub

    Private Sub ToggleGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height > 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub SetGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height <= 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub UpdateAllPanels()
        ' -----------------------------------------------------------
        LockWindowUpdate(GroupBox1.Handle.ToInt32)
        ' ----------------------------------------------------------- Use this method if some GBOX is not located on the form
        'GroupBox4.Parent = Me
        'GroupBox4.Left = GroupBox1.Left
        ' ----------------------------------------------------------- Ensure the correct height also if INI is not ok
        SetGboxHeight(GroupBox1)
        SetGboxHeight(GroupBox2)
        SetGboxHeight(GroupBox3)
        ' ----------------------------------------------------------- Set the vertical positions
        GroupBox3.Top = ClientSize.Height - GroupBox3.Height - 8
        GroupBox2.Top = GroupBox3.Top - GroupBox2.Height - 6
        'GroupBox1.Top = GroupBox2.Top - GroupBox1.Height - 6

        GroupBox1.Top = 7
        GroupBox1.Height = GroupBox2.Top - 12

        ' ----------------------------------------------------------- Set the contained TextBox height
        'txt_Debug.Height = GroupBox2.Height - 31
        ' ----------------------------------------------------------- Set the Form minimum height
        Dim topSize As Int32 = Me.Size.Height - Me.ClientSize.Height
        Dim MinHeight As Int32 = 240 +
                                 GroupBox2.Height +
                                 GroupBox3.Height + topSize + 28
        If MinHeight < 160 Then MinHeight = 160
        Me.MinimumSize = New Size(Me.MinimumSize.Width, MinHeight)
        ' -----------------------------------------------------------
        LockWindowUpdate(0)
    End Sub

    Private Sub GroupBoxes_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles GroupBox1.Paint,
                                                                                                                 GroupBox2.Paint,
                                                                                                                 GroupBox3.Paint
        Dim gb As GroupBox = CType(sender, GroupBox)
        Dim bounds As New Rectangle(0, 0, gb.Width, gb.Height)
        If gb.Width <= 0 Or gb.Height <= 0 Then Return
        Dim brush As New Drawing2D.LinearGradientBrush(bounds,
                                                       Color.FromArgb(60, 255, 255, 255),
                                                       Color.FromArgb(40, 0, 0, 0),
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub


    ' ===============================================================================================
    '  CHANGE ZOOM with CTRL WHEEL
    ' ===============================================================================================
    Private Sub WV2_ZoomFactorChanged(sender As Object, e As EventArgs) Handles WV2.ZoomFactorChanged
        If Not EventsAreEnabled Then Return
        Dim z As Int32
        Select Case WV2.ZoomFactor
            Case Is < 0.28 : z = 0
            Case Is < 0.32 : z = 1
            Case Is < 0.37 : z = 2
            Case Is < 0.45 : z = 3
            Case Is < 0.55 : z = 4
            Case Is < 0.7 : z = 5
            Case Is < 0.9 : z = 6
            Case Is < 1.1 : z = 7
            Case Is < 1.3 : z = 8
            Case Is < 1.6 : z = 9
            Case Is < 1.9 : z = 10
            Case Is < 2.25 : z = 11
            Case Is < 2.75 : z = 12
            Case Is < 3.5 : z = 13
            Case Is < 4.5 : z = 14
            Case Else : z = 15
        End Select
        If z = 0 Then Return
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        tkbar_Zoom.Value = z
        EventsAreEnabled = old
    End Sub

    Friend Sub Set_ZOOM(Optional ByVal ForceNewZoom As Boolean = False)
        Dim z As Single
        Select Case tkbar_Zoom.Value
            Case 0 : z = 0.25
            Case 1 : z = 0.3
            Case 2 : z = 0.35
            Case 3 : z = 0.4
            Case 4 : z = 0.5
            Case 5 : z = 0.6
            Case 6 : z = 0.8
            Case 7 : z = 1.0
            Case 8 : z = 1.2
            Case 9 : z = 1.4
            Case 10 : z = 1.8
            Case 11 : z = 2.0
            Case 12 : z = 2.5
            Case 13 : z = 3.0
            Case 14 : z = 4.0
            Case Else : z = 5.0
        End Select
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If ForceNewZoom Then
            WV2.ZoomFactor = 0.1
            PrintTextBox.ZoomFactor = 0.1
        End If
        WV2.ZoomFactor = z
        If z < 1 Then z = 1
        If z > 2 Then z = 2
        PrintTextBox.ZoomFactor = z
        PrintTextBox.Font = New Font("courier New", 9, FontStyle.Bold)
        If z > 1.8 Then z = 1.8
        txt_Debug.Font = New Font("courier New", 9 * z, FontStyle.Bold)
        MenuStrip_Exit.Font = New Font("Tahoma", 12 * z)
        EventsAreEnabled = old
    End Sub

    Private Sub SetSpeed(n As Int32)
        Select Case n
            Case 1 : LoopMillisec = 400
            Case 2 : LoopMillisec = 200
            Case 3 : LoopMillisec = 100
            Case 4 : LoopMillisec = 50
            Case 5 : LoopMillisec = 20
            Case 6 : LoopMillisec = 10
            Case 7 : LoopMillisec = 4
            Case 8 : LoopMillisec = 1
            Case 9 : LoopMillisec = 0 : SleepEveryNloops = 3
            Case 10 : LoopMillisec = 0 : SleepEveryNloops = 7
            Case 11 : LoopMillisec = 0 : SleepEveryNloops = 16
            Case 12 : LoopMillisec = 0 : SleepEveryNloops = Int32.MaxValue
        End Select
        Select Case n
            Case 9 : tkbar_Speed.BackColor = Color.FromArgb(255, 220, 0)
            Case 10 : tkbar_Speed.BackColor = Color.FromArgb(255, 200, 0)
            Case 11 : tkbar_Speed.BackColor = Color.FromArgb(255, 180, 0)
            Case 12 : tkbar_Speed.BackColor = Color.FromArgb(255, 150, 0)
            Case Else : tkbar_Speed.BackColor = tkbar_Zoom.BackColor
        End Select
    End Sub

    ' ===============================================================================================
    '  SHOW and HIDE Text and TOOLS
    ' ===============================================================================================
    Private Sub ShowHideTextAndTools()
        ' --------------------------------------------------------------------- hide/show program text
        'Dim GBoxProgramTextLength As Single
        'Dim txt As String = "Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
        'GBoxProgramTextLength = TextRenderer.MeasureText(txt, GroupBox_MainArea.Font).Width
        'If Running AndAlso GBoxProgramTextLength + 10 < GroupBox_MainArea.ClientSize.Width Then
        '    GroupBox_MainArea.Text = txt
        'ElseIf GBoxProgramTextLength + 10 < chk_Comment.Left Then
        '    GroupBox_MainArea.Text = txt
        'Else
        '    GroupBox_MainArea.Text = ""
        'End If
        ' --------------------------------------------------------------------- hide/show label_lines
        Label_Lines.Visible = Label_Lines.Left > tkbar_Transparency.Right
        ' --------------------------------------------------------------------- hide/show speed z opacity
        tkbar_Speed.Visible = tkbar_Speed.Right + 10 < GroupBox_MainArea.Width
        tkbar_Zoom.Visible = tkbar_Zoom.Right + 10 < GroupBox_MainArea.Width
        tkbar_Transparency.Visible = tkbar_Transparency.Right + 10 < GroupBox_MainArea.Width
    End Sub

    ' ===============================================================================================
    '  TRACK BARS
    ' ===============================================================================================
    Private Sub Tkbar_Speed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Speed.ValueChanged
        If Not EventsAreEnabled Then Return
        SetSpeed(tkbar_Speed.Value)
        'ShowExecutionDelayText(tkbar_Speed.Value)
        tkbar_Speed.Refresh()
    End Sub
    Private Sub Tkbar_Zoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Zoom.ValueChanged
        If Not EventsAreEnabled Then Return
        Set_ZOOM()
        'tkbar_Zoom.Refresh()
    End Sub

    Private Sub Tkbar_Transparency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Transparency.ValueChanged
        If Not EventsAreEnabled Then Return
        SetFormOpacity()
        tkbar_Transparency.Refresh()
    End Sub

    Private Sub SetFormOpacity()
        Me.Opacity = 1 - tkbar_Transparency.Value / 20.0F
    End Sub

End Class
