﻿Imports System.Runtime.InteropServices
Imports System.Threading

Module Module_Utils

    Friend Running As Boolean

    ' =======================================================================================================
    '   APP TITLE AND VERSION (ALL FIELDS)
    ' =======================================================================================================
    Friend Function AppTitleAndVersion(Optional ByVal RemoveThereminoPrefix As Boolean = False) As String
        Dim appname As String = IO.Path.GetFileNameWithoutExtension(Application.ExecutablePath)
        Dim Title As String = Replace(appname, "_", " ")
        If RemoveThereminoPrefix Then Title = Replace(Title, "Theremino ", "")
        Return Title + " - V" + GetVersionString()
    End Function

    ' =======================================================================================================
    '   GET VERSION (ALSO TRIPLE OR QUADRUPLE FIELDS)
    ' =======================================================================================================
    Friend Function GetVersionString() As String
        Dim s() As String = Split(My.Application.Info.Version.ToString, ".")
        GetVersionString = s(0) + "." + s(1)
        If s(2) <> "0" Then
            GetVersionString += "." + s(2)
            If s(3) <> "0" Then
                GetVersionString += "." + s(3)
            End If
        End If
    End Function


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private WithEvents TTP1 As New ToolTip
    Friend Sub ToolTips_Init()
        TTP1.ShowAlways = True
        TTP1.UseAnimation = True
        TTP1.UseFading = True
        TTP1.IsBalloon = True
        TTP1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        TTP1.ReshowDelay = 500
        '
        ' --------------------------------------------------------------- Undo / Redo / Load / Save
        TTP1.SetToolTip(Form1.Chk_ControlsUndo, "Undo the last changes")
        TTP1.SetToolTip(Form1.Chk_ControlsRedo, "Redo the last changes")
        TTP1.SetToolTip(Form1.Chk_ControlsLoad, "Open a dialog to load a program." + vbCrLf + "Press the right button to reload this program.")
        TTP1.SetToolTip(Form1.Chk_ControlsSave, "Open a dialog to save the program with another name." + vbCrLf + "Press the right button to save the program with a single click.")
        '
        ' --------------------------------------------------------------- Speed
        Dim s As String = ""
        s += " Speed 12 -  300uS/row - CPU 60% " + vbCrLf
        s += " Speed 11 -  400uS/row - CPU 50% " + vbCrLf
        s += " Speed 10 -  600uS/row - CPU 40% " + vbCrLf
        s += vbCrLf
        s += " Speed   9 -    1mS/row - CPU 30% " + vbCrLf
        s += " Speed   8 -    2mS/row - CPU 25% " + vbCrLf
        s += " Speed   7 -    6mS/row - CPU 20% " + vbCrLf
        s += vbCrLf
        s += " Speed   6 -  12mS/row - CPU 15% " + vbCrLf
        s += " Speed   5 -  25mS/row - CPU 10% " + vbCrLf
        s += " Speed   4 -  50mS/row - CPU  8% " + vbCrLf
        s += vbCrLf
        s += " Speed   3 - 100mS/row - CPU  5% " + vbCrLf
        s += " Speed   2 - 200mS/row - CPU  2% " + vbCrLf
        s += " Speed   1 - 400mS/row - CPU  1% " + vbCrLf
        s += vbCrLf
        s += " Times referred to fast PCs with SSD"
        TTP1.SetToolTip(Form1.tkbar_Speed, s)
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    'Private Sub controls_MouseEnter(ByVal sender As Object, _
    '                               ByVal e As System.EventArgs) Handles txt_CommSpeed.MouseEnter, _
    '                                                                    txt_MinChange.MouseEnter, _
    '                                                                    txt_CapArea.MouseEnter
    '    ttp1.Active = False
    '    ttp1.Active = True
    'End Sub

    'Friend Function StringToInt32(ByVal s As String) As Int32
    '    Dim n As Double = Val(s)
    '    If n < Int32.MinValue Or n > Int32.MaxValue Then Return 0
    '    Return CInt(n)
    'End Function

    ' ==========================================================================================================
    '   SELECT VALUE IN PROGRESSION
    ' ==========================================================================================================
    Friend Function SelectValueInProgression(ByVal value As Single, ByVal delta As Int32) As Single
        Dim Progression() As Single = {0.1, 0.2, 0.5, 1, 2, 5, 10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000}
        Dim i As Int32
        For i = 0 To Progression.Length - 1
            If value <= Progression(i) Then Exit For
        Next
        i += delta
        i = Math.Max(i, 0)
        i = Math.Min(i, Progression.Length - 1)
        Return Progression(i)
    End Function


    ' =======================================================================================================
    '   CULTURE INFO FOR STRING CONVERSIONS
    ' =======================================================================================================
    Friend CultureInfo As Globalization.CultureInfo = Globalization.CultureInfo.InvariantCulture

    ' =======================================================================================================
    '   MIXED FUNCTIONS
    ' =======================================================================================================
    Friend Function ReplaceMultipleSpacesAndTabAndTrim(ByVal s As String) As String
        s = s.Replace(vbTab, " ")
        While s.Contains("  ")
            s = s.Replace("  ", " ")
        End While
        Return s.Trim
    End Function

    Friend Function CursorInsideControl(ByVal ctl As Control) As Boolean
        Return ctl.ClientRectangle.Contains(ctl.PointToClient(Cursor.Position))
    End Function

    Friend Function CorrectMicrometricMouse(ByVal Delta As Int32) As Int32
        Static sum As Int32 = 0
        sum += Delta
        If Math.Abs(sum) < 120 Then Return 0
        CorrectMicrometricMouse = sum \ 120
        sum = 0
    End Function

    Friend Function RemoveComments(ByRef s As String) As Int32
        Dim i As Int32 = s.IndexOf("'")
        If i > 0 Then s = s.Remove(i).TrimEnd
        If i = 0 Then s = ""
        Return i
    End Function

    ' =======================================================================================================
    '   SOUNDS
    ' =======================================================================================================
    Friend Sub Click1()
        My.Computer.Audio.Play(My.Resources.Click1, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click1b()
        My.Computer.Audio.Play(My.Resources.Click1b, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click1c()
        My.Computer.Audio.Play(My.Resources.Click1c, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click2()
        My.Computer.Audio.Play(My.Resources.Click2, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click3()
        My.Computer.Audio.Play(My.Resources.Click3, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click4()
        My.Computer.Audio.Play(My.Resources.Click4, AudioPlayMode.WaitToComplete)
    End Sub
    Friend Sub Click5()
        My.Computer.Audio.Play(My.Resources.Click5, AudioPlayMode.WaitToComplete)
    End Sub

    ' =============================================================================================
    '  WINDOWS SCHEDULER PRECISION
    ' ============================================================================================= 
    Private Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Friend Sub SchedulerMaxPrecision()
        If OperatingSystemIsWindows Then
            timeBeginPeriod(1)
        End If
    End Sub
    Friend Sub SchedulerDefaultPrecision()
        If OperatingSystemIsWindows Then
            timeEndPeriod(1)
        End If
    End Sub

    ' ==============================================================
    '  RICH TEXT BOX - SUPPRESS SOUNDS (call from KeyDown)
    ' ==============================================================
    Friend Sub RichTextBox_SuppressSounds(ByVal sender As Object, ByRef e As KeyEventArgs)
        Dim rtb As RichTextBox = CType(sender, RichTextBox)
        If rtb.GetLineFromCharIndex(rtb.SelectionStart) = 0 AndAlso
                                            (e.KeyData = Keys.Up Or e.KeyData = Keys.PageUp) _
        OrElse rtb.GetLineFromCharIndex(rtb.SelectionStart) = rtb.GetLineFromCharIndex(rtb.TextLength) AndAlso
                                            (e.KeyData = Keys.Down Or e.KeyData = Keys.PageDown) _
        OrElse rtb.SelectionStart = rtb.TextLength AndAlso e.KeyData = Keys.Right _
        OrElse rtb.SelectionStart = 0 AndAlso
                (e.KeyData = Keys.Left Or (e.KeyData = Keys.Back And rtb.SelectionLength = 0)) Then
            e.Handled = True
        End If
    End Sub


    ' ======================================================================================================
    '  ASYNC KEY STATE
    ' ======================================================================================================
    Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Int32) As Int16
    Private Const PRESSED_NOW As Int32 = &H8000
    Private Const PRESSED_AFTER_PREVIOUS_CALL As Int32 = &H1

    Friend Function KeyPressedNow(ByVal k As Int32) As Boolean
        KeyPressedNow = (GetAsyncKeyState(k) And PRESSED_NOW) <> 0
    End Function

    Friend Function KeyPrevious(ByVal k As Int32) As Boolean
        KeyPrevious = (GetAsyncKeyState(k) And PRESSED_AFTER_PREVIOUS_CALL) <> 0
    End Function

    Private Declare Function VkKeyScan Lib "user32" Alias "VkKeyScanA" (ByVal chr As Int16) As Int16
    Friend Function KeyCodeToVirtualKey(ByVal k As Int32) As Int16
        If k > 65535 Then k = 0
        Return VkKeyScan(CShort(k))
    End Function

    Friend Sub WaitMouseOff()
        While KeyPressedNow(Keys.LButton) Or KeyPressedNow(Keys.MButton) Or KeyPressedNow(Keys.RButton)
            Thread.Sleep(1)
        End While
    End Sub

    Friend Sub WaitKeyOff(ByVal WaitKey As Int32)
        Do
            Thread.Sleep(1)
        Loop Until Not KeyPressedNow(WaitKey)
    End Sub


    ' =======================================================================================================
    '  ONLY Positive Integer NUMERIC COMBO BOX
    ' -------------------------------------------------------------------------------------------------------
    '  Call from KeyDown event with: OnlyNumericComboBox(sender, e)
    ' =======================================================================================================
    Friend Sub OnlyNumericComboBox(ByVal sender As Object, ByVal e As KeyEventArgs)
        ' ------------------------------------------------------ Allow navigation keyboard arrows
        Select Case e.KeyCode
            Case Keys.Up, Keys.Down, Keys.Left, Keys.Right, Keys.PageUp, Keys.PageDown, Keys.Delete
                e.SuppressKeyPress = False
                Return
        End Select
        ' ------------------------------------------------------ Block non-number characters
        Dim currentKey As Char = Chr(e.KeyCode)
        If Not My.Computer.Keyboard.CtrlKeyDown And
           Not Char.IsControl(currentKey) And
           Not Char.IsDigit(currentKey) And
           Not e.KeyCode = Keys.OemMinus And
           Not e.KeyCode = Keys.OemPeriod Then
            e.SuppressKeyPress = True
        End If
        ' -------------------------------------------------------- no decimal point
        If e.KeyCode = Keys.OemPeriod Then
            e.SuppressKeyPress = True
        End If
        ' -------------------------------------------------------- no minus sign
        If e.KeyCode = Keys.OemMinus Then
            e.SuppressKeyPress = True
        End If
        ' ------------------------------------------------------- Handle pasted Text
        If e.Control AndAlso e.KeyCode = Keys.V Then
            ' --------------------------------------------------- Preview paste data (removing non-number characters)
            Dim pasteText As String = Clipboard.GetText
            Dim strippedText As String = ""
            Dim i As Integer = 0
            Do While i < pasteText.Length
                If Char.IsDigit(pasteText(i)) Then
                    strippedText += pasteText(i).ToString
                End If
                i += 1
            Loop
            ' --------------------------------------------------- If there were non-numbers in the pasted text
            If strippedText <> pasteText Then

                e.SuppressKeyPress = True
                ' ----------------------------------------------- OPTIONAL: Manually insert text stripped of non-numbers
                Dim tbox As ComboBox = CType(sender, ComboBox)
                Dim start As Integer = tbox.SelectionStart
                Dim newTxt As String = tbox.Text
                newTxt = newTxt.Remove(tbox.SelectionStart, tbox.SelectionLength)
                ' ----------------------------------------------- remove highlighted text
                newTxt = newTxt.Insert(tbox.SelectionStart, strippedText)
                ' ----------------------------------------------- paste
                tbox.Text = newTxt
                tbox.SelectionStart = start + strippedText.Length
            Else
                e.SuppressKeyPress = False
            End If
        End If
    End Sub

    ' ================================================================================================
    '   CALC ZOOM FACTOR
    ' ================================================================================================
    Friend Function CalcZoomFactor(ByVal ControlSize As Size, ByVal W As Single, ByVal H As Single) As Single
        Dim ZoomFactorW As Double = ControlSize.Width / W
        Dim ZoomFactorH As Double = ControlSize.Height / H
        Return CSng(Math.Min(ZoomFactorH, ZoomFactorW))
    End Function

    ' ================================================================================================
    '   DEBUG
    ' ================================================================================================
    Friend Sub Debug1(ByVal s1 As String, ByVal s2 As String, ByVal a() As Int32)
        If Not My.Computer.Keyboard.AltKeyDown Then Return
        DebugPrint(s1.PadRight(40) + s2.PadLeft(22) + " " + a.Length.ToString.PadRight(3) + " --- " + Debug_IntArrayToString(a))
    End Sub

    Friend Sub DebugPrint(ByVal s As String)
        Debug.Print(s)
    End Sub

    Private Function Debug_IntArrayToString(ByVal a() As Int32) As String
        Dim s As String = ""
        For i As Int32 = 0 To a.Length - 1
            s += a(i).ToString.PadRight(4)
        Next
        Return s
    End Function


    ' ===============================================================================================================
    '  TEST COMMAND SLOT and WRITE RESPONSES 
    ' ===============================================================================================================
    Private ReadOnly CommandsSlot As Int32 = 1
    Private TextCommand As String
    Friend Sub TestCommandSlot()
        If CommandsSlot > 0 Then
            TextCommand = StringSlots.ReadString(CommandsSlot)
            StringSlots.WriteString(CommandsSlot, "")
            If TextCommand <> "" Then
                ' ------------------------------------------------------- remove spaces and comments
                TextCommand = ReplaceMultipleSpacesAndTabAndTrim(TextCommand)
                RemoveComments(TextCommand)
                ' ------------------------------------------------------- split line
                Dim sa() As String = TextCommand.Split(" "c)
                If sa.Length = 0 Then Return
                ' ------------------------------------------------------- extract params
                Dim n(9) As Double
                If sa.Length < n.Length Then
                    For i As Int32 = 1 To n.Length - 1
                        If i < sa.Length Then
                            n(i) = Val(sa(i))
                        End If
                    Next
                End If
                ' ------------------------------------------------------- decode
                Select Case sa(0).ToLower
                    Case "average"
                        'Me.txt_AverageSec.NumericValueInteger = CInt(n(1))
                        '
                    Case "minimize"
                        Form1.WindowState = FormWindowState.Minimized
                    Case "maximize"
                        Form1.WindowState = FormWindowState.Maximized
                    Case "normal"
                        Form1.WindowState = FormWindowState.Normal
                        '
                    Case "imagename"
                        If sa.Length > 1 Then
                            'SaveImageFromControl(GroupBox_MainArea, sa(1))
                        End If
                        '
                    Case Else
                        ErrorBeep()
                End Select
                'SendResponses()
            End If
        End If
    End Sub

    Private Sub ErrorBeep()
        Console.Beep(660, 50)
        Console.Beep(440, 50)
        Console.Beep(220, 150)
    End Sub


    Friend Declare Function LockWindowUpdate Lib "user32" (ByVal hWnd As Integer) As Integer



End Module
