
// ------------------------------------------------------------------ POST MESSAGE EXAMPLE
//chrome.webview.postMessage(vName);

// ------------------------------------------------------------------ HILIGHT BLOCK
//var HilightedBlock;
function highlightBlock(id)
{
    //HilightedBlock = workspace.getBlockById(id).type;     
    workspace.highlightBlock(id);
    HighlightPause = true;
    ExecutingWaitBlock = false;
}

// ------------------------------------------------------------------ INIT TOOLBOX and WORKSPACE
var workspace;
function initToolboxAndWorkspace(toolboxXML, workspaceXML) 
{
    workspace = 
    Blockly.inject
    (
        'blocklyDiv', 
        {
            media: '../../media/', toolbox: toolboxXML, 
            move:
            {
                scrollbars: 
                {
                    horizontal: true,
                    vertical: true
                },
                drag: true,
                wheel: true
            }
        }
    );
    var wx = Blockly.Xml.textToDom(workspaceXML);
    Blockly.Xml.domToWorkspace(wx, workspace);
    workspace.clearUndo();
}

// ------------------------------------------------------------------ Get WORKSPACE as text
function getWorkspaceAsText()
{
    var dom = Blockly.Xml.workspaceToDom(workspace);
    var txt = Blockly.Xml.domToPrettyText(dom);
    return txt;
}

// ------------------------------------------------------------------ Get TOOLBOX as text
function getToolboxAsText()
{
    var txt = workspace.options.languageTree;
    return txt;
}

// ------------------------------------------------------------------ Get JS-CODE as text
function getBlocklyCode()
{
    var code = Blockly.JavaScript.workspaceToCode(workspace);
    return code;
}

// ------------------------------------------------------------------ LIST VARS
function listVars() 
{
    var s = '';
    var v = workspace.getAllVariables();
    for (var i = 0; i < v.length; i++)
    {
        var name = v[i].name;
        var value = myInterpreter.globalScope.object.properties[name];
        value = value ? value.toString() : '';
        s = s + name + ' = ' + value + '\r\n';
    }
    return s;
}

//function listVars() 
//{
//    var s = '';
//    workspace.getBlocksByType("variables_set", false).forEach(function (item) 
//    {
//        var name = item.getField('VAR').getText();
//        var value = myInterpreter.globalObject.properties[name];
//        value = value ? value.toString() : '';
//        s = s + name + ' = ' + value + '\r\n';
//    });
//    return s;
//}


// ------------------------------------------------------------------ GENERATE LATEST-CODE
var globalCode;
function generateCode()
{
    Blockly.JavaScript.STATEMENT_PREFIX = 'highlightBlock(%1);\n';
    Blockly.JavaScript.addReservedWords('highlightBlock');
    globalCode = Blockly.JavaScript.workspaceToCode(workspace);
}


// ------------------------------------------------------------------ ADD CHANGE LISTENER
// https://developers.google.com/blockly/guides/configure/web/events
function addChangeListener()
{
    WorkspaceChanged = false;
    workspace.addChangeListener
    (
        function (event)
        {
            if (event.type == Blockly.Events.CLICK) 
            {
                WorkspaceChanged = true;
            }
            if (event.type == Blockly.Events.CHANGE || 
                event.type == Blockly.Events.CREATE || 
                event.type == Blockly.Events.DELETE || 
                event.type == Blockly.Events.MOVE) 
            {
                WorkspaceChanged = true;
                chrome.webview.postMessage('block_changed');
            }

            // DEBUG EVENT-TYPE
            //chrome.webview.postMessage(event.type);
        }
    );
}


// ======================================================================================
//   RUN SINGLE STEP (Debug = 600 uS/line - Release = 300 uS/line)
// ======================================================================================
var ExecutingWaitBlock = false;
var WorkspaceChanged = false;
var HighlightPause = false;
var RunningManualStep;  // If doing manual steps then exit immediately from Wait-Blocks

function runStepsUntilHilight(ManualStep) 
{
    if (myInterpreter)
    {
        RunningManualStep = ManualStep;
        HighlightPause = false;
        do 
        {
            var hasMoreCode = false;
            try 
            {
                hasMoreCode = myInterpreter.step();
            } 
            finally 
            {
                if (WorkspaceChanged) 
                {
                    WorkspaceChanged = false;
                    workspace.highlightBlock(null);
                    return 'PROGRAM_CHANGED';
                }
                 if (!hasMoreCode) 
                {
                    workspace.highlightBlock(null);
                    return 'PROGRAM_END';
                }
            }
        } while (hasMoreCode && !HighlightPause && !ExecutingWaitBlock);
    }
    return "";
}



// ======================================================================================
//   GREG CODE DISABLED - BEGIN
// ======================================================================================
var myInterpreter;

function initInterpreter()
{
    addChangeListener();
    generateCode();
    myInterpreter = new Interpreter(globalCode, initGlobal);
}

function runInterpreterStep(ManualStep) 
{
    return runStepsUntilHilight(ManualStep); 
}

function runFunctionBlock(functionName)
{
    myInterpreter.appendCode(functionName + '();');
}
// --------------------------------------------------------------------------------------
//   GREG CODE DISABLED - END
// --------------------------------------------------------------------------------------


// ======================================================================================
//   GREG CODE ENABLED - BEGIN
// ======================================================================================
//function initInterpreter()
//{
//    addChangeListener();
//    generateCode();
//    createAndActivateThread(globalCode);
//}

//function runInterpreterStep(ManualStep) 
//{
//    nextStep();
//    return '';
//}

//function runFunctionBlock(functionName)
//{
//    createAndActivateThread(functionName + '();');
//}
// --------------------------------------------------------------------------------------
//   GREG CODE ENABLED - END
// --------------------------------------------------------------------------------------


// ======================================================================================
//   GREG CODE - BEGIN
// ======================================================================================
// https://groups.google.com/g/blockly/c/39FtlxbNUYk
// https://github.com/NeilFraser/JS-Interpreter/issues/147
// https://github.com/NeilFraser/JS-Interpreter/blob/master/docs.html

// https://codepen.io/gregdyke/pen/rNvXdBG
// https://codepen.io/livioenrico/pen/VwdZaJG

 // Create an interpreter whose global scope will be the cross-thread global.
var globalInterpreter = new Interpreter('', initGlobal);
var threads = [];

function nextStep() 
{
    if (globalInterpreter.step()) 
    {
        window.setTimeout(nextStep, 0);
    } 
    else 
    {
        threads.pop();
        globalInterpreter.setStateStack(threads[threads.length-1]);
        if (threads.length > 0) 
        {
            window.setTimeout(nextStep, 0);
        }
    }
}

function createAndActivateThread(code) 
{
    var interpreter = new Interpreter('');
    interpreter.getStateStack()[0].scope = globalInterpreter.getGlobalScope();
    interpreter.appendCode(code);
    threads.push(interpreter.getStateStack());
    globalInterpreter.setStateStack(threads[threads.length-1]);
    if (threads.length == 1) 
    {
        // interpreter needs starting
        nextStep();
    }
}


// initialise globals immediately so they are available to all threads
//createAndActivateThread(globalCode);

//function run() 
//{
//    var mainCodeFromBlockly = 
//    `
//        for (count=0; count<=1000; count++) 
//        {
//            setOutput(count);
//            if (count%50 == 0) 
//            {
//                setLed(count%100==0);
//            } 
//        }
//    `;
//    createAndActivateThread(mainCodeFromBlockly);
//}

// --------------------------------------------------------------------------------------
//   GREG CODE - END
// --------------------------------------------------------------------------------------

